library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

--  Uncomment the following lines to use the declarations that are
--  provided for instantiating Xilinx primitive components.
--library UNISIM;
--use UNISIM.VComponents.all;

entity VME_AM_sub is
Port ( clk : in std_logic;
	vme_addr : in  std_logic_vector(31 downto 0);
	vme_dout : in std_logic_vector(15 downto 0);
	vme_doe : in  STD_LOGIC;
	vme_dock : in  STD_LOGIC;
	vme_doac : out  STD_LOGIC;
	vme_din : out std_logic_vector(15 downto 0);
	vme_dick : out  STD_LOGIC;
	vme_diac : in  STD_LOGIC;
	vme_length : in std_logic_vector(31 downto 0);
	vme_done : out  STD_LOGIC;

	addr_dout : out std_logic_vector(15 downto 0);
	addr_ck : out std_logic_vector(1 downto 0);
	vdt_oe : out  STD_LOGIC:='1';
	vdt_dir : out  STD_LOGIC;	--same vm(5)
	vdt_din : in std_logic_vector(15 downto 0);

	dtak : in std_logic;
	vclk : out std_logic;
	VM: out STD_LOGIC_VECTOR(5 downto 0);
-- VM(5)=WRITE, VM(4)=LW, VM(3)=LACK, VM(2)=DS1, VM(1)=DS0, VM(0)=AS
	prob: out STD_LOGIC_VECTOR(3 downto 0);
	verr : out std_logic:='0';
	bsy : out std_logic
);
end VME_AM_sub;

architecture Behavioral of VME_AM_sub is

--	signal VIN: STD_LOGIC_VECTOR(15 downto 0);
	signal dkflag, ddtak1, ddtak2, waitdtag : STD_LOGIC;
	signal bgo : STD_LOGIC:='0';
	signal pvm: STD_LOGIC_VECTOR(5 downto 0):="111111";
	signal pam: STD_LOGIC_VECTOR(5 downto 0);
	signal pa: STD_LOGIC_VECTOR(23 downto 1);
--	signal pvb: STD_LOGIC_VECTOR(3 downto 0);
	signal vadd : STD_LOGIC_VECTOR(31 downto 0);
	signal vlen : STD_LOGIC_VECTOR(31 downto 0):=(others=>'0');
	signal acct, acwait, bufdt, bufvd : STD_LOGIC_VECTOR(15 downto 0);
--	signal resetct: STD_LOGIC_VECTOR(3 downto 0);
	signal vcct: STD_LOGIC_VECTOR(1 downto 0);
	signal dvdoe, pvdick, vdick, pvdone : STD_LOGIC;
	signal dwrite : STD_LOGIC:='0';

begin

vm <= pvm;

	bsy <= bgo;
	prob(1 downto 0) <= bufdt(1 downto 0);
	prob(2) <= vme_dock;
	prob(3) <= pvdone;
	vclk <= vcct(0);
vme_dick <= vdick;
vme_doac <= dwrite;
vme_done <= pvdone;
process (CLK) 
begin
if CLK='1' and CLK'event then
	dvdoe <= vme_doe;
	if vme_dock='1' and dwrite='0' then
		dwrite <= '1';
		bufdt <= vme_dout;
	elsif dwrite='1' and pvdone='1' then
		dwrite <= '0';
	end if;
	if vcct="10" then	--from 48MHz to 16MHz
		vcct <= "00";
	else
		vcct <= vcct+1;
	end if;
	if vlen(23 downto 0)=X"000000" then
		pvdone <= '1';
		vdick <= '0';
	else
		pvdone <= '0';
	end if;
	ddtak1<=dtak;	ddtak2<=ddtak1;		--slow mode
	if vme_doe='1' and dvdoe='0' then
		vadd <= vme_addr;
		vlen <= vme_length;
		acct <= (others=>'0');
		if vme_addr(31)='1' then		--rw = address(31)
			pvm(5) <= '0';	--write
		else
			pvm(5) <= '1';	--read
		end if;
		pam <= "111101";	--AM
		dkflag <= '0';
	end if;
	if ((pvm(5)='0' and dwrite='1') or pvm(5)='1') and vlen(23 downto 0)/=X"000000" then
		if acct<=X"0001" then
			vdt_dir <= '0';	--data bus on
			acct <= acct+1;
			addr_ck <= "00";
--			addr_dout <= vadd(16)&vadd(17)&"1"&pam(3)&vadd(21)&vadd(22)&vadd(23)&
--					pvm(5)&pam(4)&vadd(18)&vadd(19)&vadd(20)&pam(1)&pam(0)&pam(5)&"1";
			addr_dout <= "1"&pvm(5)&pam(5)&pam(0)&pam(1)&pam(3)&"1"&pam(4)&vadd(23 downto 16);
			pvm(2 downto 0) <= "111";				 --off AS, off DS0 and DS1	--slow mode
			vdick <= '0';
			bgo <= '1';
		elsif acct<=X"0002" then
			acct <= acct+1;
			addr_ck(0) <= '1';
		elsif acct<=X"0003" then
			acct <= acct+1;
--			addr_dout <= "0"&vadd(1)&vadd(2)&vadd(3)&vadd(4)&vadd(5)&vadd(6)&vadd(7)&
--				vadd(8)&vadd(9)&vadd(10)&vadd(11)&vadd(12)&vadd(13)&vadd(14)&vadd(15);
			addr_dout <= vadd(15 downto 0);
		elsif acct<=X"0004" then
			acct <= acct+1;
			addr_ck(1) <= '1';
			acwait <= (others=>'0');
		elsif acct<=X"0005" then
			acct <= acct+1;
			vdt_dir <= pvm(5);	--data bus to write/read
			if pvm(5)='0' then	--if write
				addr_dout <= bufdt;
			end if;
			vdt_oe <= '0';		--data on
			pvm(2 downto 0) <= "110";				 -- on AS	--slow mode
		elsif acct<=X"000f" then
			acwait <= acwait+1;
			if ddtak1='1' and ddtak2='1' and acwait<X"1112" then
				acct <= acct+1;
			else
				acct <= X"7000";
			end if;
		elsif acct<=X"0010" then
			acct <= acct+1;
			if vadd(0)='0' and vlen(23 downto 0)=X"000001" then
				pvm(2 downto 0) <= "010";						 --on DS1
			elsif vadd(0)='1' then
				pvm(2 downto 0) <= "100";						 --on DS0
			else
				pvm(2 downto 0) <= "000";						 --on DS0,DS1
			end if;
		elsif acct<=X"00011" then
			acct <= acct+1;
			dkflag <= '0';
--		elsif acct<X"0095" then	--wait 3us at 50MHz
		elsif acct<X"00f9" then	--wait 5us at 50MHz
			acct <= acct+1;
			if ddtak1='0' and ddtak2='0' and dkflag='0' then		--slow mode
				dkflag <= '1';
				if pvm(5)='1' then	--read
					vme_din <= vdt_din;
					vdick <= '1';
				end if;
				pvm(2 downto 0) <= "110";						 --off DS0,DS1
			elsif ddtak1='1' and ddtak2='1' and dkflag='1' then
				bgo <= '0';
				pvm(2 downto 0) <= "111";						 --off AS,DS0,DS1
			end if;
		else
			if bgo='1' then
				verr <= '1';
			else
				verr <= '0';
			end if;
			bgo <= '0';
			dwrite <= '0';
			vdt_oe <= '1';	--data off
			pvm(2 downto 0) <= "111";						 --off AS,DS0,DS1
			acct <= (others=>'0');
			vdick <= '0';
			if vlen(23 downto 0)/=X"000000" then
				if (vadd(0)='0' and vlen(23 downto 0)<=X"000002") or
						vlen(23 downto 0)<=X"000001" then
					vlen(1) <= '0';
				elsif vadd(0)='1' then
					vlen(23 downto 0) <= vlen(23 downto 0)-1;
				else
					vlen(23 downto 1) <= vlen(23 downto 1)-1;
				end if;
				vlen(0) <= '0';
				vadd(23 downto 1) <= vadd(23 downto 1)+1;
				vadd(0) <= '0';
			end if;
		end if;
	end if;
end if;
end process;

end Behavioral;
