----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    07:52:11 05/13/2010 
-- Design Name: 
-- Module Name:    test_WSiT - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity test_WSiT is
    Port ( clkp : in  STD_LOGIC;
	addr_ck : out std_logic_vector(1 downto 0);
	vdt_oe : out  STD_LOGIC;
	vdt_dir : out  STD_LOGIC;
	vdt_dio : inout std_logic_vector(15 downto 0);
     mad : inout std_logic_vector(3 downto 0);	--change IP address

	DAC_cs				: out  std_logic;
	DAC_clk				: out  std_logic;
	DAC_dout				: out  std_logic;

	ADC1_cs				: out  std_logic;
	ADC1_clk				: out  std_logic;
	ADC1_din				: in  std_logic;

	t0_in				: inout  std_logic;
	t0_out				: out  std_logic;

	dtak : in std_logic;
	vclk : out std_logic;
	vds1 : out std_logic;
	vds0 : out std_logic;
	vas : out std_logic;
	vcoe : out std_logic;
--	VM: out STD_LOGIC_VECTOR(5 downto 0);
-- VM(5)=WRITE, VM(4)=LW, VM(3)=LACK, VM(2)=DS1, VM(1)=DS0, VM(0)=AS
--	VB: inout STD_LOGIC_VECTOR(3 downto 0);
-- VB(3)=BGI, VB(2)=BGO, VB(1)=BBSY, VB(0)=BRQ
	prob: out STD_LOGIC_VECTOR(3 downto 0);
	bsy : out std_logic;

	MACCLK : out  STD_LOGIC;	--25MHz
	SW_RST : inout  STD_LOGIC;
--	// EEPROM
	EEPROM_CS :		out STD_LOGIC;--	,	// out	: Chip select
	EEPROM_SK :		out STD_LOGIC;--	,	// out	: Serial data clock
	EEPROM_DI :		out STD_LOGIC;--	,	// out	: Serial write data
	EEPROM_DO :		inout STD_LOGIC;--	,	// in	: Serial read data
--	// MII interface
--	GMII_1000M :		in STD_LOGIC;--// in	: GMII mode (0:MII, 1:GMII)
	GMII_RSTn :		inout STD_LOGIC;--// in type miss	: PHY reset
--	LED_1000Mn :		in STD_LOGIC;--// in	: 1000M mode
--		// TX
--	GMII_GTXCLK :		out STD_LOGIC;--// out	: GTx clock(125MHz)
	GMII_TX_CLK :		in STD_LOGIC;--// in	: Tx clock(2.5 or 25MHz)
	GMII_TX_EN :		out STD_LOGIC;--// out	: Tx enable
	GMII_TXD :		out STD_LOGIC_VECTOR(3 downto 0);--// out	: Tx data[7:0]
	GMII_TX_ER :		out STD_LOGIC;--// out	: TX error
--		// RX
	GMII_RX_CLK :		in STD_LOGIC;--// in	: Rx clock(2.5 or 25MHz)
	GMII_RX_DV :		in STD_LOGIC;--// in	: Rx data valid
	GMII_RXD :		in STD_LOGIC_VECTOR(3 downto 0);--// in	: Rx data[7:0]
	GMII_RX_ER :		in STD_LOGIC;--// in	: Rx error
	GMII_CRS :		in STD_LOGIC;--// in	: Carrier sense
	GMII_COL :		in STD_LOGIC;--// in	: Collision detected
--		// Management IF
	GMII_MDC :		out STD_LOGIC;--// out	: Clock for MDIO
	GMII_MDIO :		inout STD_LOGIC;--// in	: Data

	led : out  STD_LOGIC);
end test_WSiT;

architecture Behavioral of test_WSiT is
component WRAP_SiTCP_GMII_XC6S_32K
Port (
	CLK :		in STD_LOGIC;--// in	: System clock
	RST :		in STD_LOGIC;--// in	: System reset
--	// Configuration parameters
	FORCE_DEFAULTn :	in STD_LOGIC;--// in	: Load default values
	EXT_IP_ADDR :	in STD_LOGIC_VECTOR(31 downto 0);--// in	: My IP address[31:0]
	EXT_TCP_PORT :	in STD_LOGIC_VECTOR(15 downto 0);--// in	: My TCP main-port #[15:0]
	EXT_RBCP_PORT :	in STD_LOGIC_VECTOR(15 downto 0);--// in	: My UDP RBCP-port #[15:0]
	PHY_ADDR :		in STD_LOGIC_VECTOR(4 downto 0);--// in	: PHY-device MIF address[4:0]
--	// EEPROM
	EEPROM_CS :		out STD_LOGIC;--	,	// out	: Chip select
	EEPROM_SK :		out STD_LOGIC;--	,	// out	: Serial data clock
	EEPROM_DI :		out STD_LOGIC;--	,	// out	: Serial write data
	EEPROM_DO :		in STD_LOGIC;--	,	// in	: Serial read data
--		// user data, intialial values are stored in the EEPROM, 0xFFFF_FC3C-3F
	USR_REG_X3C :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3C
	USR_REG_X3D :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3D
	USR_REG_X3E :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3E
	USR_REG_X3F :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Stored at 0xFFFF_FF3F
--	// MII interface
	GMII_RSTn :		out STD_LOGIC;--// in	: PHY reset
	GMII_1000M :		in STD_LOGIC;--// in	: GMII mode (0:MII, 1:GMII)
--		// TX
	GMII_TX_CLK :		in STD_LOGIC;--// in	: Tx clock(2.5 or 25MHz)
	GMII_TX_EN :		out STD_LOGIC;--// out	: Tx enable
	GMII_TXD :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Tx data[7:0]
	GMII_TX_ER :		out STD_LOGIC;--// out	: TX error
--		// RX
	GMII_RX_CLK :		in STD_LOGIC;--// in	: Rx clock(2.5 or 25MHz)
	GMII_RX_DV :		in STD_LOGIC;--// in	: Rx data valid
	GMII_RXD :		in STD_LOGIC_VECTOR(7 downto 0);--// in	: Rx data[7:0]
	GMII_RX_ER :		in STD_LOGIC;--// in	: Rx error
	GMII_CRS :		in STD_LOGIC;--// in	: Carrier sense
	GMII_COL :		in STD_LOGIC;--// in	: Collision detected
--		// Management IF
	GMII_MDC :		out STD_LOGIC;--// out	: Clock for MDIO
	GMII_MDIO_IN :		in STD_LOGIC;--// in	: Data
	GMII_MDIO_OUT :		out STD_LOGIC;--// out	: Data
	GMII_MDIO_OE :		out STD_LOGIC;--// out	: MDIO output enable
--	// User I/F
	SiTCP_RST :		out STD_LOGIC;--// out	: Reset for SiTCP and related circuits
--		// TCP connection control
	TCP_OPEN_REQ :		in STD_LOGIC;--// in	: Request to connect connection
	TCP_OPEN_ACK :		out STD_LOGIC;--// out	: Acknowledge for open (=Socket busy)
	TCP_ERROR :		out STD_LOGIC;--// out	: TCP error, its active period is equal to MSL
	TCP_CLOSE_REQ :		out STD_LOGIC;--// out	: Connection close
	TCP_CLOSE_ACK :		in STD_LOGIC;--// in	: Acknowledge for close
--		// FIFO I/F
	TCP_RX_WC :		in STD_LOGIC_VECTOR(15 downto 0);--// in	: Fill level[15:0]
	TCP_RX_WR :			out STD_LOGIC;--// out	: Write enable
	TCP_RX_DATA :		out STD_LOGIC_VECTOR(7 downto 0);--// out	: Write data[7:0]
	TCP_TX_FULL :		out STD_LOGIC;--// out	: Almost full flag
	TCP_TX_WR :			in STD_LOGIC;--// in	: Write enable
	TCP_TX_DATA :		in STD_LOGIC_VECTOR(7 downto 0);--// in	: Write data[7:0]
--		// RBCP
	RBCP_ACT :		out STD_LOGIC;--// out	: RBCP active
	RBCP_ADDR :		out STD_LOGIC_VECTOR(31 downto 0);--// out	: Address[31:0]
	RBCP_WD :			out STD_LOGIC_VECTOR(7 downto 0);--// out	: Data[7:0]
	RBCP_WE :			out STD_LOGIC;--// out	: Write enable
	RBCP_RE :			out STD_LOGIC;--// out	: Read enable
	RBCP_ACK :		in STD_LOGIC;--// in	: Access acknowledge
	RBCP_RD :			in STD_LOGIC_VECTOR(7 downto 0)--// in	: Read data[7:0]
);
end component;
component SiTCP_sub
    Port ( clk : in  STD_LOGIC;
	vme_addr : out  std_logic_vector(31 downto 0);
	vme_dout : out std_logic_vector(15 downto 0);
	vme_doe : out  STD_LOGIC;
	vme_dock : out  STD_LOGIC;
	vme_doac : in  STD_LOGIC;
	vme_din : in std_logic_vector(15 downto 0);
	vme_dick : in  STD_LOGIC;
	vme_diac : out  STD_LOGIC;
	vme_length : out std_logic_vector(31 downto 0);
	vme_done : in  STD_LOGIC;
	prob: out STD_LOGIC_VECTOR(3 downto 0);

	tx_wd : out std_logic_vector(7 downto 0);
	tx_we : out  STD_LOGIC;
	tx_afull : in  STD_LOGIC;
	rx_rd : in std_logic_vector(7 downto 0);
	rx_rv : in  STD_LOGIC;
	rx_re : out  STD_LOGIC;
	close_req : in  STD_LOGIC;
	close_ack : out  STD_LOGIC;
	active : in  STD_LOGIC);
end component;
component VME_AM_sub
Port ( clk : in std_logic;
	vme_addr : in  std_logic_vector(31 downto 0);
	vme_dout : in std_logic_vector(15 downto 0);
	vme_doe : in  STD_LOGIC;
	vme_dock : in  STD_LOGIC;
	vme_doac : out  STD_LOGIC;
	vme_din : out std_logic_vector(15 downto 0);
	vme_dick : out  STD_LOGIC;
	vme_diac : in  STD_LOGIC;
	vme_length : in std_logic_vector(31 downto 0);
	vme_done : out  STD_LOGIC;

	addr_dout : out std_logic_vector(15 downto 0);
	addr_ck : out std_logic_vector(1 downto 0);
	vdt_oe : out  STD_LOGIC;
	vdt_dir : out  STD_LOGIC;	--same vm(5)
	vdt_din : in std_logic_vector(15 downto 0);

	dtak : in std_logic;
	vclk : out std_logic;
	VM: out STD_LOGIC_VECTOR(5 downto 0);
-- VM(5)=WRITE, VM(4)=LW, VM(3)=LACK, VM(2)=DS1, VM(1)=DS0, VM(0)=AS
	prob: out STD_LOGIC_VECTOR(3 downto 0);
	verr, bsy : out std_logic
);
end component;
component set_DAC16
port (clk : in std_logic; 
 	dabeg : in std_logic; 
 	dabusy : out std_logic; 
 	dadata : in std_logic_vector(15 downto 0); 
	DAC_cs				: out  std_logic;
	DAC_clk				: out  std_logic;
	DAC_dout				: out  std_logic
 		); 
end component;
component UDP_sub
Port ( clk, clk3x : in std_logic;
	loc_addr : in  STD_LOGIC_VECTOR (31 downto 0);
	loc_wd : in  STD_LOGIC_VECTOR (7 downto 0);
	loc_we : in  STD_LOGIC;
	loc_re : in  STD_LOGIC;
	loc_ack : out  STD_LOGIC;
	loc_rd : out  STD_LOGIC_VECTOR (7 downto 0);

	t0_in : in  STD_LOGIC;
	t0_out : out  STD_LOGIC;
	t0_on : out  STD_LOGIC;

	tmce : out std_logic;
	tmadd : out std_logic_vector(2 downto 0);
	tmdi : out std_logic_vector(15 downto 0);
	tmdo : in std_logic_vector(15 downto 0)
);
end component;
component get_sADC12_50 is
port (clk : in std_logic; 
 	abeg : in std_logic; 
 	abusy : out std_logic; 
 	adata : out std_logic_vector(11 downto 0); 
	ADC_cs				: out  std_logic;
	ADC_clk				: out  std_logic;
	ADC_din				: in  std_logic
 		); 
end component;

	signal iclk, clk0, clk2x, clkb, clkfb, locked, ptcp_establish, ptcp_cls_req, tcp_cls_ack : STD_LOGIC;
	signal mdio_in, mdio_out, mdio_oe, c25mhz, c25mhzb, clk2p5x, clk2p5xb, reset : STD_LOGIC;
	signal G1000M, int_GMII_TX_CLK, clk0_2, clkb_2, clk3x, clk3xb, locked_2 : STD_LOGIC;
	signal buf1 : STD_LOGIC_VECTOR(7 downto 0);
	signal buf2 : STD_LOGIC_VECTOR(7 downto 0);
	signal ledct : STD_LOGIC_VECTOR(25 downto 0);
	signal tx_wd, rx_rd : STD_LOGIC_VECTOR(7 downto 0);
	signal tx_we, tx_afull, rx_rv, rx_re : STD_LOGIC;

	signal pGMII_TXD, pGMII_RXD : STD_LOGIC_VECTOR(7 downto 0);
	signal vme_addr : std_logic_vector(31 downto 0);
	signal vme_dout : std_logic_vector(15 downto 0);
	signal vme_doe : STD_LOGIC;
	signal vme_dock : STD_LOGIC;
	signal vme_doac : STD_LOGIC;
	signal vme_din : std_logic_vector(15 downto 0);
	signal vme_dick : STD_LOGIC;
	signal vme_diac : STD_LOGIC;
	signal vme_length : std_logic_vector(31 downto 0);
	signal vme_done : STD_LOGIC;
	signal addr_dout, vdt_din : std_logic_vector(15 downto 0);
	signal pvdt_dir : STD_LOGIC;
	signal verr : STD_LOGIC:='0';
	signal pvm : std_logic_vector(5 downto 0);
--	signal end_wait_ct : std_logic_vector(15 downto 0);
	signal my_ip_add : STD_LOGIC_VECTOR(31 downto 0);

   signal loc_addr : STD_LOGIC_VECTOR (31 downto 0);
   signal loc_we : STD_LOGIC;
   signal loc_wd, loc_rd : STD_LOGIC_VECTOR (7 downto 0);
   signal loc_re, loc_ack : STD_LOGIC;

	signal tmce : std_logic;
	signal tmadd : std_logic_vector(2 downto 0);
	signal tmdi, tmdo : std_logic_vector(15 downto 0);
	signal inital_dac : STD_LOGIC_VECTOR(2 downto 0):="000";
	signal dabeg, dabusy : STD_LOGIC;
	signal dadata : std_logic_vector(15 downto 0);
--	signal t0_in : STD_LOGIC;
	signal abeg, abusy : STD_LOGIC;
	signal adata : std_logic_vector(11 downto 0);

	signal testcheckct : STD_LOGIC_VECTOR(23 downto 0);
	signal testkpct : STD_LOGIC_VECTOR(15 downto 0);
--	signal test_hz : STD_LOGIC_VECTOR(15 downto 0);
	signal t1usct : STD_LOGIC_VECTOR(5 downto 0);
	signal pt0_out, t0_on, no_t0 : STD_LOGIC;

begin
u0: ibufg port map(I=>clkp, O=>iclk);
--u1: DCM_PS generic map(CLKDV_DIVIDE =>2.0, CLKFX_DIVIDE =>2, CLKFX_MULTIPLY => 5)
u1: DCM_SP generic map(CLKDV_DIVIDE =>2.0, CLKFX_DIVIDE =>2, CLKFX_MULTIPLY => 5)
 port map(clkin=>iclk, clkfb=>clkfb, clk0=>clk0, LOCKED=>locked, rst=>'0',
	CLKDV=>c25mhz, CLKFX=>clk2p5x, clk2x=>clk2x);
u2: bufg port map(I=>clk0, O=>clkfb);
u4: bufg port map(I=>clk2p5x, O=>clk2p5xb);
u15: bufg port map(I=>clk0, O=>clkb);
u16: bufg port map(I=>c25mhz, O=>c25mhzb);
--u5 : BUFGMUX port map (
--      O => int_GMII_TX_CLK,    -- Clock MUX output
--      I0 => GMII_TX_CLK,  -- Clock0 input
--      I1 => CLK2p5x,  -- Clock1 input, 125MHz
--      S => G1000M     -- Clock select input
--   );
--G1000M <= not LED_1000Mn;
G1000M <= '0';	-- not LED_1000Mn;
GMII_MDIO <= mdio_out when mdio_oe='1' else 'Z';
mdio_in <= GMII_MDIO;

--u11: DCM_PS generic map(CLKFX_DIVIDE =>1, CLKFX_MULTIPLY => 3)
u11: DCM_SP generic map(CLKFX_DIVIDE =>1, CLKFX_MULTIPLY => 3)
 port map(clkin=>clkb, clkfb=>clkb_2, clk0=>clk0_2, CLKFX=>clk3x, LOCKED=>locked_2, rst=>not locked);
u12: bufg port map(I=>clk0_2, O=>clkb_2);
u14: bufg port map(I=>clk3x, O=>clk3xb);

vdt_din <= vdt_dio;
vdt_dio <= addr_dout when pvdt_dir='0' else (others=>'Z');
vdt_dir <= pvdt_dir;
vds0 <= pvm(1);
vds1 <= pvm(2);
vas <= pvm(0);
vcoe <= pvm(0);

u19: vme_am_sub port map(clkb,	vme_addr, vme_dout, vme_doe,
	vme_dock, vme_doac, vme_din, vme_dick, vme_diac, vme_length, vme_done,
	addr_dout, addr_ck, vdt_oe, pvdt_dir, vdt_din, dtak, vclk,
	pvm, open, verr, bsy);
u20: SiTCP_sub port map(clkb,	vme_addr, vme_dout, vme_doe, vme_dock, vme_doac,
	vme_din, vme_dick, vme_diac, vme_length, vme_done, prob, tx_wd, tx_we, tx_afull,
	rx_rd, rx_rv, rx_re, ptcp_cls_req, tcp_cls_ack, ptcp_establish);

--led(0) <= ptcp_establish or ledct(25);
led <= ledct(21) when vme_done='0' else
	ledct(23) when verr='1' else ledct(25);
puerom: pullup port map(O=>EEPROM_DO);
pdd1: oddr2 port map(c0=>c25mhzb, c1=>not c25mhzb, Q=>MACCLK, ce=>'1', d0=>'1', d1=>'0', r=>'0', s=>'0');
--MACCLK <= c25mhz;
--GMII_GTXCLK <= CLK2p5x;	--125MHz @50MHz
purst: pullup port map(O=>GMII_RSTn);
pusw: pullup port map(O=>SW_RST);
reset <= not SW_RST or not locked or not locked_2;
--reset <= SW_RST or not locked or not locked_2;	--for avnet
pGMII_RXD <= "0000"&GMII_RXD(3 downto 0);
GMII_TXD <= pGMII_TXD(3 downto 0);
--pGMII_RXD <= GMII_RXD(7 downto 0);
--GMII_TXD <= pGMII_TXD(7 downto 0);

--IP address=192.168.0.16, port=24
--u30: WRAP_SiTCP_GMII_XC4_32K port map(clk3xb, reset, '1', X"c0a80010", X"0018", X"1234", "00000",
u30: WRAP_SiTCP_GMII_XC6S_32K port map(clkb, reset, '0', my_ip_add, X"0018", X"1234", "00000",
					--IP address=192.168.2.16~31
	EEPROM_CS, EEPROM_SK, EEPROM_DI, EEPROM_DO, open, open, open, open,
	GMII_RSTn , G1000M ,GMII_TX_CLK, GMII_TX_EN, pGMII_TXD, GMII_TX_ER, GMII_RX_CLK, GMII_RX_DV,
--	GMII_RSTn , G1000M ,GMII_TX_CLK, GMII_TX_EN, pGMII_TXD, open, GMII_RX_CLK, GMII_RX_DV,
	pGMII_RXD, GMII_RX_ER, GMII_CRS, GMII_COL, GMII_MDC, MDIO_IN, MDIO_OUT, MDIO_OE,
	open, '0', ptcp_establish, open, ptcp_cls_req, tcp_cls_ack,
	X"0000", rx_rv, rx_rd, tx_afull, tx_we, tx_wd,
--	open, open, buf2, open, open, '0', buf2);
	open, loc_addr, loc_wd, loc_we, loc_re, loc_ack, loc_rd);

GEN2:	for i in 0 to 3 generate
pum: pullup port map(O=>mad(i));
end generate;

u33: UDP_sub port map(clkb, clk3xb, loc_addr, loc_wd, loc_we, loc_re, loc_ack, loc_rd, t0_in, pt0_out, t0_on,
	tmce, tmadd, tmdi, tmdo);
--prob <= tmce;
pu0: pullup port map(O=>t0_in);
--t0_in <= t0_ct(20);
t0_in <= '0' when testkpct>X"0007" and testkpct<X"4ff0" and no_t0='1' else 'Z';
t0_out <= t0_in when t0_on='0' else pt0_out;

u40: set_DAC16
port map (clkb, dabeg, dabusy, dadata, DAC_cs, DAC_clk, DAC_dout); 
u42: get_sADC12_50 port map(clkb, abeg, abusy, adata, ADC1_cs, ADC1_clk, ADC1_din);

process (CLKb) 
begin
if CLKb='1' and CLKb'event then
	ledct <= ledct+1;

	if t1usct<"110001" then		--make 1 u-second pulse @50MHz (49).
		t1usct <= t1usct+1;
		if abusy='1' and abeg='1' then	--for read ADC
			abeg <= '0';
		end if;
	else
		t1usct <= (others=>'0');
		if t0_in='0' and testkpct>X"5000" and testkpct<X"9c30" then
			testcheckct <= (others=>'0');
			no_t0 <= '0';
		elsif testcheckct<X"2dc6c0" then	--2010 4/5, 10/24 if kp is high and <3secnd
			testcheckct <= testcheckct+1;
			no_t0 <= '0';
		else
			no_t0 <= '1';
		end if;
--		if no_t0='1' and testkpct<X"9c40" then	--2010 4/5, 10/24 2secnd
		if testkpct<X"9c3f" then	--2014 1/19, 25Hz
			testkpct <= testkpct+1;
		else
			testkpct <= (others=>'0');
			abeg <= '1';
		end if;
	end if;

	if inital_dac="000" and dabeg='0' then
		if dabusy='0' then
			dabeg <= '1';
			dadata <= X"0000";	--output0=off
			inital_dac <= inital_dac+1;
		end if;
--		test_hz <= X"00f9";	--5us changing, generating 100kHz.
	elsif inital_dac="001" and dabeg='0' then
		if dabusy='0' then
			dabeg <= '1';
			dadata <= X"9040";	--output1=0.06V
			inital_dac <= inital_dac+1;
		end if;
	else
		if tmce='1' and tmadd="000" then
			dabeg <= '1';
			dadata <= tmdi;	--set DAC
		elsif tmce='1' and tmadd="001" then
--			test_hz <= tmdi;	--set DAC
--		elsif tmce='1' and tmadd="010" then
--			t_count(31 downto 16) <= tmdi;	--set test count high
--			t_flag <= '0';
--			test_ct <= (others=>'0');
--		elsif tmce='1' and tmadd="011" then
--			t_count(15 downto 0) <= tmdi;	--set test count low
--			t_flag <= '1';
		elsif dabeg='1' and dabusy='1' then
			dabeg <= '0';
		end if;
	end if;
	if tmadd="000" then
		tmdo <= dadata;	--get DAC
	elsif tmadd="001" then
		tmdo <= "0000"&adata;	--get ADC
--	elsif tmadd="010" then
--		tmdo <= t_count(31 downto 16);	--get test count high
--	elsif tmadd="011" then
--		tmdo <= t_count(15 downto 0);	--get test count low
	end if;

	my_ip_add(31 downto 4) <= X"c0a8021";
	my_ip_add(3 downto 0) <= mad;
--	if ptcp_establish='1' then
--		resetf <= '0';
--		end_wait_ct <= (others=>'0');
--	elsif verr='1' or vme_done='1' or end_wait_ct=X"ffff" then
--		end_wait_ct <= end_wait_ct+1;
--		resetf <= '1';
--	end if;
end if;
end process;
end Behavioral;

